import rospy
from clever import srv
from std_srvs.srv import Trigger
import time
import math

rospy.init_node('flight')
HEIGHT = 1.5
get_telemetry = rospy.ServiceProxy('get_telemetry', srv.GetTelemetry)
land = rospy.ServiceProxy('land', Trigger)
navigate = rospy.ServiceProxy('navigate', srv.Navigate)
set_position = rospy.ServiceProxy('set_position', srv.SetPosition)
set_velocity = rospy.ServiceProxy('set_velocity', srv.SetVelocity)
set_attitude = rospy.ServiceProxy('set_attitude', srv.SetAttitude)

telem = get_telemetry('aruco_map')


def nav(x1, y1, z1, accuracy=0.5, speed=0.7):
    telem = get_telemetry('aruco_map')
    navigate(x=x1, y=y1, z=z1, speed=speed,
             frame_id='aruco_map', auto_arm=False, yaw=0)
    while True:
        if (abs(x1-telem.x) < accuracy and abs(y1-telem.y) < accuracy):
            break
        time.sleep(0.1)
        telem = get_telemetry('aruco_map')


navigate(x=0, y=0, z=1.5, speed=0.5, frame_id='body', auto_arm=True)
time.sleep(5)
k = 1
while k != 10:
    nav(0, 0, HEIGHT, speed=1)
    nav(2.34, 2.56, HEIGHT, speed=1)
    nav(0, 2.37, HEIGHT, speed=1)
    nav(2.56, 0, HEIGHT, speed=1)
    print(k)
    k = k + 1

res = land()
if res.success:
    print('Copter is landing')
